package ru.ulstu.configuration;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springdoc.core.GroupedOpenApi;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class SwaggerConfiguration {
    private final Logger log = LoggerFactory.getLogger(SwaggerConfiguration.class);

    @Bean
    public GroupedOpenApi swaggerApi() {
        log.info("Creating Swagger API configuration bean");
        return GroupedOpenApi.builder()
                .group("timetable-api")
                .pathsToMatch(ApiConfiguration.API_1_0 + "**")
                .build();
    }
}
